<template src="./template.html"></template>

<script lang="ts">
import {
  Component,
  getModule,
  Prop,
  Vue,
  Watch,
} from "nuxt-property-decorator";
import axios from "axios";
import { loadScript } from "@paypal/paypal-js";
// //@ts-ignore
// import { VueperSlides, VueperSlide } from "vueperslides";
// import "vueperslides/dist/vueperslides.css";
//@ts-ignore
import VueSlickCarousel from "vue-slick-carousel";
import "vue-slick-carousel/dist/vue-slick-carousel.css";
// optional style for arrows & dots
import "vue-slick-carousel/dist/vue-slick-carousel-theme.css";

import Swal from "sweetalert2";
import { apiErrorHandler, redirectPage } from "~/utils/apiHanlers";
import { api } from "~/common/constaint";
import CartModule from "~/store/cart";
import ProductModule from "~/store/product";
import { clientLanguageKey } from "~/utils/common";
import _, { cloneDeep, unionBy } from "lodash";
import apiPlugin from "~/plugins/api";
import { resources } from "~/interfaces/api";
var moment = require("moment");
@Component({
  components: {
    VueSlickCarousel,
  },
})
export default class ProductComponent extends Vue {
  cart = getModule(CartModule, this.$store);
  productModule = getModule(ProductModule, this.$store);

  config: any = {
    page: 1,
    limit: 25,
    search: "",
  };

  settings = {
    focusOnSelect: true,
    infinite: true,
    speed: 500,
    slidesToShow: 4,
    slidesToScroll: 5,
    centerMode: true,
  };
  dialogReview = false;
  dialogCommentReview = false;
  idxCarousel = 0;
  panel = 0;
  // productId: any = "";
  // product: any = {};
  productSlug = "";

  listImage: any = [];
  listVariant: any = [];
  imageId = "";

  payload: any = {
    productId: "",
    variantId: "",
    quantity: 1,
  };
  slug = "";

  combo: any = {};
  listProductIds = [];
  listRelatedProductIds = [];

  listRecentlyViewed = [];
  listBestSeller = [];

  selected: any = null;

  loading = false;
  loadingBuy = false;
  loadingAddAllTocart = false;
  loadingTable = false;

  review = {
    productId: "",
    email: "",
    name: "",
    phoneNumber: "",
    rating: 0,
    content: "",
    replyTo: "",
  };
  listImgReview = [];
  listImageRender = [];

  isHeightReview = false;
  listShipping = [];

  get loadingPaypal() {
    return this.$store.state.product.loadingPaypal;
  }

  get reviews() {
    return this.$store.state?.product?.product?.reviews || [];
  }

  get publicKeyPaypal() {
    return this.$store.state.cart.publicKeyPaypal;
  }

  get enablePaypal() {
    const route = this.$route.path.split("/");
    if (route.length > 1) {
      return false;
    }
    const listPayment = this.$store.state.cart?.listPayment || [];

    const findIndex = listPayment.findIndex(
      (payment: any) => payment.type === "paypal"
    );
    return this.$store.state.cart?.listPayment[findIndex]?.status;
  }

  isClickImage = "carousel-right";
  parseImageThumb = "";

  head() {
    return {
      title:
        this.$store.state.setting.siteInfo &&
        this.$store.state.setting.siteInfo.webTitle,
      link: [
        {
          rel: "icon",
          type: "image/x-icon",
          href: `${api}/${
            this.$store?.state?.setting?.siteInfo?.logo?.imageUrl || ""
          }`,
        },
      ],
    };
  }

  created() {
    //@ts-ignore
    if (this.$vuetify.breakpoint.name === "xs") {
      this.settings = {
        focusOnSelect: true,
        infinite: true,
        speed: 500,
        slidesToShow: 4,
        slidesToScroll: 5,
        centerMode: true,
      };
    }
    //@ts-ignore
    if (this.$vuetify.breakpoint.name === "sm") {
      this.settings = {
        focusOnSelect: true,
        infinite: true,
        speed: 500,
        slidesToShow: 4,
        slidesToScroll: 5,
        centerMode: true,
      };
    }

    if (
      //@ts-ignore
      this.$vuetify.breakpoint.name !== "xs" &&
      //@ts-ignore
      this.$vuetify.breakpoint.name !== "sm"
    ) {
      this.settings = {
        focusOnSelect: true,
        infinite: true,
        speed: 500,
        slidesToShow: 5,
        slidesToScroll: 5,
        centerMode: true,
      };
    }
  }

  async mounted() {
    // await this.onGetDetailProduct();
    // this.onGetListRecentlyViewed();
    // this.onGetListBestSeller();
    this.setScriptPaypal();
    clearInterval(this.x);
    if (
      this.product &&
      this.product.listVariant &&
      this.product.listVariant.length
    ) {
      this.product.listVariant.forEach((variant: any) => {
        variant.selected = 0;
      });
    }
    if (
      this.product &&
      this.product.listVariant &&
      this.product.listVariant.length
    ) {
      this.changedCarouselRight(this.product.listVariant[0]._id, 0);
    } else {
      this.idxCarousel = 0;
      this.isClickImage = "carousel-left";
    }
    this.changedCarousel(0);
    // this.onGetListCombo();
    // await this.$store.dispatch("promotion/getPromotionDetail", {
    // 	ctx: this,
    // });

    // let listProductIdViewer = this.$cookies.get("listProductIdViewer");
    // if (!listProductIdViewer) {
    // 	this.$cookies.set("listProductIdViewer", []);
    // } else {
    // 	listProductIdViewer.push(this.productId);
    // 	listProductIdViewer = _.uniq(listProductIdViewer);
    // 	this.$cookies.set("listProductIdViewer", listProductIdViewer);
    // }
    // this.onGetListShipping();
    this.onCalcTimer();
    // let listProductIdViewer = JSON.parse(
    // 	//@ts-ignore
    // 	localStorage.getItem("listProductIdViewer")
    // );
    // if (!listProductIdViewer) {
    // 	localStorage.setItem("listProductIdViewer", JSON.stringify([]));
    // } else {
    // 	listProductIdViewer.push(this.productId);
    // 	listProductIdViewer = _.uniq(listProductIdViewer);
    // 	localStorage.setItem(
    // 		"listProductIdViewer",
    // 		JSON.stringify(listProductIdViewer)
    // 	);
    // }
  }

  // ----------------------------------------------------------- PAYPAL --------------------------------------------------------------
  async onGetListShipping() {
    try {
      this.loadingTable = true;
      const response = await this.$api.shipping.listShippingUser(this.config);
      if (response?.data?.data) {
        this.listShipping = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async setScriptPaypal() {
    let paypal;
    try {
      paypal = await loadScript({
        "client-id": this.publicKeyPaypal,
      });
    } catch (error) {}
    if (paypal) {
      try {
        this.setLoaded();
      } catch (error) {
        console.error("failed to render the PayPal Buttons", error);
      }
    }
    this.$store.commit("product/setLoadingPaypal", false);
    // this.loadingPaypal = true;
    // const that = this;
    // const script = document.createElement("script");
    // script.async = true;
    // script.src = `https://www.paypal.com/sdk/js?client-id=${this.publicKeyPaypal}&components=buttons,funding-eligibility`;
    // script.onload = await function () {
    // 	that.setLoaded();
    // 	that.loadingPaypal = false;
    // };
    // document.body.appendChild(script);
    //@ts-ignore
    // await script.addEventListener("load", );
  }

  async setLoaded() {
    const that = this;
    //@ts-ignore
    const paypal = window.paypal;
    let orderCodePaypal = "";
    let paymentMethodId = "";
    const domain = window.location.host || "san-pham-1.zshop.cc";
    //@ts-ignore
    await window.paypal
      .Buttons({
        createOrder: async function (data: any, actions: any) {
          try {
            const payload = {
              // productId: that.productId,
              variantSellerId: that.payload.variantId,
              quantity: parseInt(that.payload.quantity),
            };
            const response = await that.$api.cart.paypalCreateOrderDirect(
              payload,
              domain
            );
            if (response && response.data) {
              paymentMethodId = response.data.paymentMethodId;
              orderCodePaypal = response.data.orderCode;
              return response.data.id;
            }
          } catch (error) {
            apiErrorHandler(error, that);
          }
        },
        onApprove: async function (data: any, actions: any) {
          const { paymentID, payerID } = data;
          if (!paymentID || !payerID || !paymentMethodId) return;
          const response = await that.$api.cart.completePaypalPayment({
            paymentMethodId,
            paymentID,
            payerID,
          });
          //@ts-ignore
          that.$fb.enable();
          //@ts-ignore
          that.$fb.track("Purchase", {
            currency: "USD",
            value: that.priceVariant || 1,
          });
          if (response.data) {
            that.$router.push(
              `/order-success?order_code=${response.data.orderCode.replace(
                "#",
                ""
              )}`
            );

            // Swal.fire({
            // 	title: `Completed`,
            // 	text: `Your order will be processed by us. Order code is ${response.data.orderCode}`,
            // 	icon: "success",
            // 	confirmButtonColor: "#41b882",
            // 	confirmButtonText: "Done",
            // }).then(() => {
            // 	redirectPage(
            // 		`/pages/order-tracking?orderCode=${response.data.orderCode.replace(
            // 			"#",
            // 			""
            // 		)}`
            // 	);
            // });
          }
        },
        //@ts-ignore
        onCancel: async function (isFail?: boolean) {
          Swal.fire({
            title: `${that.$language.failed}`,
            text: `${that.$language.cancelSuccessfully}`,
            icon: "error",
            confirmButtonColor: "#FF5252",
            confirmButtonText: "Agree",
          });
          // that.$pushNotification.success(
          // 	`Cancellation of payment successfully`
          // );
        },
        //@ts-ignore
        // fundingSource: paypal.FUNDING.PAYPAL,
      })
      //@ts-ignore
      .render(this.$refs.paypal);
  }

  openDialogReview() {
    this.review = {
      productId: this.product._id,
      email: "",
      name: "",
      phoneNumber: "",
      rating: 5,
      content: "",
      replyTo: "",
    };
    this.dialogReview = true;
  }
  // async onGetListReviewProduct() {
  // 	try {
  // 		this.loadingTable = true;
  // 		const response = await this.$api.product.listProductReview(
  // 			this.product.slug
  // 		);
  // 		if (response?.data) {
  // 			this.$store.commit(
  // 				"product/setListReviewProduct",
  // 				response.data
  // 			);
  // 		}
  // 	} catch (error) {
  // 		apiErrorHandler(error, this);
  // 	} finally {
  // 		this.loadingTable = false;
  // 	}
  // }

  onSelectImage() {
    //@ts-ignore
    this.$refs.fileImage.$refs.input.click();
  }
  onChangeImage(e: any) {
    if (e.length > 0 && e.length < 4) {
      this.listImgReview = [];
      this.listImageRender = [];
      for (let item of e) {
        if (!item.type.includes("image/")) {
          continue;
        }
        this.listImage;
      }
      this.listImgReview = e;
      for (let item of e) {
        this.createImage(item);
      }
    } else {
      return this.$pushNotification.error(
        `${this.$language.onlyUpThreePictures}`
      );
    }
  }

  createImage(e: any) {
    const reader = new FileReader();
    reader.onload = (e) => {
      //@ts-ignore
      this.listImageRender.push(e.target.result);
    };
    reader.readAsDataURL(e);
  }

  get productId() {
    return this.$store.state.product.productId;
  }

  get product() {
    const productStore = _.cloneDeep(this.$store.state.product.product);
    // productStore.relatedProduct.forEach((product: any) => {
    // 	if (product.variant && product.variant.length) {
    // 		product.variant.forEach((variant: any) => {
    // 			variant.name = variant.listValue.join(" / ");
    // 		});
    // 	}
    // });

    // productStore.priceProduct = 0;
    // if (productStore.variant && productStore.variant.length) {
    // 	for (let variant of productStore.variant) {
    // 		productStore["priceProduct"] += variant.price;
    // 	}
    // }
    if (productStore.listImageId && productStore.listImageId.length) {
      for (let product of productStore.listImageId) {
        const { imageUrl, id } = product;
        if (imageUrl) {
          this.listImage.push({
            imageUrl: `${api}/${imageUrl}`,
            imageId: id,
          });
        }
      }
    }
    if (productStore.listVariant && productStore.listVariant.length) {
      this.listImage = unionBy(this.listImage, "imageUrl");
      this.listVariant = productStore.listVariant;
      this.listVariant.forEach((variant: any) => {
        if (variant && variant.imageId && variant.imageId.imageUrl) {
          variant.imageId.imageUrl = `${variant?.imageId?.imageUrl || ""}`;
        }
      });
    }
    return productStore;
  }

  get $language() {
    return this.$store.state.product.language;
  }

  async onCreateCart() {
    try {
      await this.$store.dispatch("cart/createCart");
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onAddToCart() {
    try {
      //@ts-ignore
      // const cartInfo = JSON.parse(localStorage.getItem("cartInfo"));
      // this.payload.productId = this.productId;
      // if (!cartInfo) {
      // 	return this.$pushNotification.error("CartId not found");
      // }
      // if (!this.payload.productId) {
      // 	return this.$pushNotification.error("No products found");
      // } else if (this.payload.quantity < 1) {
      // 	return this.$pushNotification.error(
      // 		`${this.$language.numberNotBeLess1}`
      // 	);
      // }
      // this.loading = true;
      // const response = await this.$api.cart.addToCart(
      // 	cartInfo._id,
      // 	this.payload
      // );
      let cart: any = JSON.parse(localStorage.getItem("cart")) || [];
      const findIdxProductExist = cart.findIndex(
        (variant: any) => variant._id === this.payload.variantId
      );
      if (findIdxProductExist !== -1) {
        cart[findIdxProductExist].quantity += 1;
      } else {
        if (this.product?.listVariant?.length) {
          const findVariant = this.product.listVariant.find(
            (variant: any) => variant._id === this.payload.variantId
          );
          if (findVariant) {
            let payload: any = {
              ...findVariant,
              quantity: 1,
            };
            cart.push(payload);
          }
        }
      }
      // if (response.data) {
      // await this.$store.dispatch("product/getListRelatedProduct", {
      // 	ctx: this,
      // 	productSlug: this.product.slug,
      // });
      // this.productSlug = this.product.slug;
      this.$store.commit("product/setDialogAdded", {
        value: true,
        type: "product",
      });
      this.$store.commit("product/setDialogAdded", {
        value: false,
        type: "bestSeller",
      });
      this.$store.commit("product/setDialogAdded", {
        value: false,
        type: "recently",
      });
      localStorage.setItem("cart", JSON.stringify(cart));
      this.$store.commit("cart/setListCart", cart);
      // this.$store.commit("cart/setCartInfoAdded", response.data);
      // this.$store.dispatch("cart/getListCart", {
      // 	ctx: this,
      // 	cartId: cartInfo._id,
      // });
      //@ts-ignore
      this.$fb.enable();
      //@ts-ignore
      this.$fb.track("AddToCart");
      this.$pushNotification.success(`${this.$language.addToCartSuccessfully}`);
      // }
      this.loading = true;
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onBuyItNow() {
    try {
      //@ts-ignore
      const cartInfo = JSON.parse(localStorage.getItem("cartInfo")) || {};
      this.payload.productId = this.productId;
      if (!cartInfo) {
        return this.$pushNotification.error("CartId not found");
      }
      if (!this.payload.productId) {
        return this.$pushNotification.error("No products found");
      } else if (this.payload.quantity < 1) {
        return this.$pushNotification.error(
          `${this.$language.numberNotBeLess1}`
        );
      }
      this.loadingBuy = true;
      const response = await this.$api.cart.addToCart(
        cartInfo._id,
        this.payload
      );
      if (response.data) {
        //@ts-ignore
        this.$fb.enable();
        //@ts-ignore
        this.$fb.track("AddToCart");
        // await this.$store.dispatch("product/getListRelatedProduct", {
        // 	ctx: this,
        // 	productSlug: this.product.slug,
        // });
        this.productSlug = this.product.slug;
        this.$store.commit("cart/setCartInfoAdded", response.data);
        this.$store
          .dispatch("cart/getListCart", {
            ctx: this,
            cartId: cartInfo._id,
          })
          .then(() => {
            // window.location.href = `${window.location.origin}/checkout`;
            this.$router.push("/checkout");
          });
      }
      this.loadingBuy = true;
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingBuy = false;
    }
  }

  async onAddAllToCart() {
    try {
      //@ts-ignore
      const cartInfo = JSON.parse(localStorage.getItem("cartInfo")) || {};
      this.payload.productId = this.productId;
      if (!cartInfo) {
        return this.$pushNotification.error("CartId not found");
      }
      if (!this.payload.productId) {
        return this.$pushNotification.error("No products found");
      } else if (this.payload.quantity < 1) {
        return this.$pushNotification.error(
          `${this.$language.numberNotBeLess1}`
        );
      }
      //@ts-ignore
      const listAddToCart = [];
      listAddToCart.push(this.payload);
      for (let id of this.listProductIds) {
        const findProduct = this.combo.listProductId.find(
          (product: any) => product._id === id
        );
        if (findProduct) {
          listAddToCart.push({
            productId: findProduct._id,
            variantId: findProduct.variantId,
            quantity: 1,
          });
        }
      }
      for (let id of this.listRelatedProductIds) {
        const findProduct = this.product.relatedProduct.find(
          (product: any) => product._id === id
        );
        if (findProduct) {
          listAddToCart.push({
            productId: findProduct._id,
            variantId: findProduct.variantId,
            quantity: 1,
          });
        }
      }
      const payload = {
        listAddToCart,
      };
      const response = await this.$api.cart.addAllToCart(cartInfo._id, payload);
      //@ts-ignore
      this.$fb.enable();
      //@ts-ignore
      this.$fb.track("AddToCart");
      await this.$store.commit("cart/setCartInfoAdded", response.data);
      await this.$store
        .dispatch("cart/getListCart", {
          ctx: this,
          cartId: cartInfo._id,
        })
        .then(() => {
          this.$pushNotification.success(
            `${this.$language.addToCartSuccessfully}`
          );
          redirectPage("/cart");
        });
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingAddAllTocart = false;
    }
  }

  onDecrease() {
    this.payload.quantity -= 1;
  }

  onIncrease() {
    this.payload.quantity += 1;
  }

  openDialogAddTocart() {
    this.$store.commit("product/setDialogAddToCart", true);
  }

  changedCarousel(i: number) {
    this.isClickImage = "carousel-left";
    this.parseImageThumb = "";
    this.idxCarousel = i;
    //@ts-ignore
    this.imageId = this.listImage[i].imageId;
    if (this.listImage[i].imageId) {
      this.imageId = this.listImage[i].imageId;
    }
  }
  isShowCarousel = true;
  variantActive: any = {};
  changedCarouselRight(id: string, idx: number) {
    this.isClickImage = "carousel-right";
    // const findVariant = this.listVariant[idx];
    // if (findVariant && findVariant._id) {
    // 	this.payload.variantId = findVariant._id;
    // }

    if (
      this.product.listVariantOptionId &&
      this.product.listVariantOptionId.length
    ) {
      let product = cloneDeep(this.product);
      product.listVariantOptionId.forEach((variant: any) => {
        if (variant._id === id) {
          variant.selected = idx;
        }
      });
      this.$store.commit("product/setProduct", product);
    }

    const variantSelected = this.product.listVariantOptionId.map(
      (variant: any) => variant.values[variant.selected]
    );
    const findVariant = this.product.listVariant.find((variant: any) => {
      return variant.listValue.join(" / ") === variantSelected.join(" / ");
    });
    this.variantActive = findVariant;
    let findIdx = -1;
    if (findVariant) {
      findIdx = this.listImage.findIndex(
        (img: any) => img.imageId === findVariant._id
      );
      if (findVariant.imageId && findVariant.imageId.imageUrl) {
        this.parseImageThumb = `${api}/${findVariant.imageId.imageUrl}`;
      }
      if (findVariant._id) {
        this.payload.variantId = findVariant._id;
      }
    }

    if (findIdx === -1) {
      this.selected = null;
      //@ts-ignore
      this.idxCarousel = null;
    } else {
      this.idxCarousel = findIdx;
      this.selected = idx;

      setTimeout(() => {
        document
          .getElementsByClassName(`carousel-item-left${this.idxCarousel}`)[0]
          //@ts-ignore
          .click();
      }, 300);
    }
    this.imageId = id;
    //@ts-ignore
    // //@ts-ignore
    // this.$refs.carouselClick.click();
  }

  convertImg(product: any) {
    if (product?.coverId?.imageUrl) {
      return `${api}/${product.coverId.imageUrl}`;
    }
    return "";
  }

  convertImageReply(image: string) {
    return `${api}/${image}`;
  }

  convertImageReview(url: string) {
    return `${api}/${url}`;
  }

  convertImage(comboProduct: any) {
    if (comboProduct.variant.length) {
      const findVariant = comboProduct.variant.find(
        (variant: any) => variant._id === comboProduct.variantId
      );
      if (findVariant?.imageId?.imageUrl) {
        return `${api}/${findVariant.imageId.imageUrl}`;
      }
      return "";
    } else if (comboProduct?.coverId?.imageUrl) {
      return `${api}/${comboProduct.coverId.imageUrl}`;
    }
    return "";
  }

  calcPrice(product: any) {
    let price = 0;
    if (product.variant && product.variant.length) {
      for (let variant of product.variant) {
        price += variant.price;
      }
    } else {
      price = product.salePrice;
    }
    return price;
  }

  get priceSale() {
    if (this.variantActive && this.variantActive.price) {
      const promotionStauts = this.$store.state.promotion.promotionStauts;
      if (promotionStauts == 0) {
        return this.variantActive.comparePrice;
      } else {
        return this.variantActive.price;
      }
    } else {
      return this.product.salePrice;
    }
  }

  get priceProduct() {
    if (this.variantActive && this.variantActive.comparePrice) {
      return this.variantActive.comparePrice;
    } else {
      return this.product.price;
    }
  }

  get priceVariant() {
    if (this.variantActive && this.variantActive.comparePrice) {
      return this.variantActive.price;
    } else {
      return this.product.salePrice;
    }
  }

  get stateVariant() {
    const findVariant = this.product.variant[this.selected];
    return findVariant || {};
  }

  get statusPromotion() {
    const promotion = this.$store.state.promotion.promotion;
    return promotion.status ? true : false;
  }

  get totalPriceAddTocart() {
    let price = 0;
    for (let id of this.listProductIds) {
      const findProduct = this.combo.listProductId.find(
        (product: any) => product._id === id
      );
      price += this.calcPriceProductCombo(findProduct);
    }
    for (let id of this.listRelatedProductIds) {
      const findProduct = this.product.relatedProduct.find(
        (product: any) => product._id === id
      );
      price += this.calcPriceProductCombo(findProduct);
    }
    return price;
  }

  get promotionStauts() {
    return this.$store.state.promotion.promotionStauts;
  }

  imgThumbnail() {
    const findImageThumbnail = this.listImage[this.idxCarousel];
    if (findImageThumbnail) {
      return findImageThumbnail.imageUrl;
    }
    if (this.parseImageThumb) {
      return "";
    }
    return `${api}/${this.product.listVariant[0].imageId.imageUrl}`;
  }

  calcPriceProductCombo(product: any) {
    if (product.variantId) {
      if (product.variant.length) {
        const findPrice = product.variant.find(
          (variant: any) => variant._id === product.variantId
        );
        if (findPrice) {
          return findPrice.price;
        }
      }
    } else {
      return product.price;
    }
    return 0;
  }

  get totalPriceRelatedAddTocart() {
    let price = 0;
    for (let id of this.listRelatedProductIds) {
      const findProduct = this.combo.relatedProduct.find(
        (product: any) => product._id === id
      );
      price += this.calcPriceRelatedProduct(findProduct);
    }
    return price;
  }

  get siteInfo() {
    return this.$store.state.setting.siteInfo;
  }

  onSliceString(str: string) {
    if (str) {
      const regexImg = /<img.*?src="(.*?)"/g;
      const result = str.replaceAll(regexImg, "");
      return result;
    }
    return "";
  }

  get isCustomShowDescription() {
    let description = cloneDeep(this.product.description);
    const result = this.onSliceString(description);
    if (result.length < 1000) return "short";
    return "middle";
  }

  calcPriceRelatedProduct(product: any) {
    if (product.variantId) {
      if (product.variant.length) {
        const findPrice = product.variant.find(
          (variant: any) => variant._id === product.variantId
        );
        if (findPrice) {
          return findPrice.price;
        }
      }
    } else {
      return product.price;
    }
    return 0;
  }

  convertImageCarousel(imageUrl: string) {
    if (imageUrl) {
      return imageUrl;
    }
    return "";
  }
  convertImageProduct(imageUrl: string) {
    return `${api}/${imageUrl}`;
  }

  formatDate(date: string) {
    return moment(date).format("HH:mm YYYY/MM/DD");
  }

  onSliceEmail(email: string) {
    if (email) {
      const emailSplit = email.split("@");
      const emailLeft = emailSplit[0].slice(0, 4) + "****";
      const emailRight = emailSplit[1];
      const emailResult = `${emailLeft}@${emailRight}`;
      return emailResult;
    }
    return "";
  }

  timer = "";
  x: any = null;
  onCalcTimer() {
    const that = this;
    this.x = setInterval(function () {
      const promotion = that.$store.state.promotion.promotion;
      const promotionStauts = that.$store.state.promotion.promotionStauts;
      if (promotionStauts === 1) {
        // Get today's date and time
        var now = new Date().getTime();
        // Find the distance between now and the count down date
        var distance = promotion.to * 1000 - now;
        // Time calculations for days, hours, minutes and seconds
        var days = Math.floor(distance / (1000 * 60 * 60 * 24));
        var hours = Math.floor(
          (distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60)
        );
        var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
        var seconds = Math.floor((distance % (1000 * 60)) / 1000);
        that.timer = `${
          days
            ? days < 10
              ? `0${days} ${days > 1 ? `days` : "day"} `
              : `${days} ${days > 1 ? `days` : "day"} `
            : ""
        }${hours ? (hours < 10 ? `0${hours}:` : `${hours}:`) : "00:"}${
          minutes ? (minutes < 10 ? `0${minutes}:` : `${minutes}:`) : "00:"
        }${seconds ? (seconds < 10 ? `0${seconds}` : `${seconds}`) : ""}`;
        if (distance < 0) {
          clearInterval(that.x);
          that.timer = "";
        }
      } else {
        clearInterval(that.x);
        that.timer = "";
      }
    }, 1000);
  }
}
</script>

<style src="./style.css"></style>
<style lang="scss" scoped>
.main-img {
  margin: 0 auto;
  max-width: 366px;
  width: 100%;
  height: 366px;
  img {
    width: 100%;
    height: 100%;
    object-fit: scale-down;
  }
}
.input-fr {
  border: 0 !important;
  p {
    font-size: clamp(14px, 1.5vw, 16px);
    line-height: 150%;
    color: white;
  }
  .quantity-input {
    background: white;
    max-width: 105px;
    width: 100%;
    border: 1px solid #dbdbdb;
    height: 50px;
    .quanity-number {
      max-width: 32px;
      outline: 0;
      border: 0 !important;
      text-align: center;
      padding: 0;
    }
    @media (max-width: 960px) {
      margin: 0 0 8px;
    }
  }
  .cart-btn {
    max-width: 167px;
    width: 100%;
    height: 50px;
    background: #1b1b1b;
    display: flex;
    align-items: center;
    justify-content: center;
    border-radius: 4px;
    @media (max-width: 960px) {
      max-width: 100%;
      margin: 0 0 8px;
    }
  }
  .buy-btn {
    max-width: 150px;
    width: 100%;
    height: 50px;
    background: #ff4343;
    display: flex;
    align-items: center;
    justify-content: center;
    border-radius: 4px;
    @media (max-width: 960px) {
      max-width: 100%;
      margin: 0 0 8px;
    }
  }
}
.litmit-announce {
  font-size: 13px;
  line-height: 150%;
  letter-spacing: 0.25px;
  .limit {
    color: red;
  }
  .number {
    margin: 0 4px;
    font-weight: 700;
  }
}
</style>
